CREATE OR REPLACE FUNCTION isNumeric (param in varchar2) RETURN CHAR AS
  dummy number;
BEGIN
  dummy:=TO_NUMBER(param);
  RETURN('1');
EXCEPTION
  when others then
  RETURN('0');
END;
/

CREATE SEQUENCE  SEQ_INMUEBLES 
MINVALUE 0 MAXVALUE 9999999 INCREMENT BY 1 
START WITH 1 NOCACHE  ORDER  NOCYCLE ;


CREATE SEQUENCE  SEQ_TIEMPO 
MINVALUE 0 MAXVALUE 9999999 INCREMENT BY 1 
START WITH 1 NOCACHE  ORDER  NOCYCLE ;


CREATE SEQUENCE  SEQ_ZONA 
MINVALUE 0 MAXVALUE 9999999 INCREMENT BY 1 
START WITH 1 NOCACHE  ORDER  NOCYCLE ;


CREATE SEQUENCE  SEQ_TEMP_INTERVALZONAS 
MINVALUE 0 MAXVALUE 9999999 INCREMENT BY 1 
START WITH 1 NOCACHE  ORDER  NOCYCLE ;
commit;


CREATE TABLE INMUEBLES (
   	IDINMUEBLE NUMBER(15,0) NOT NULL ENABLE, 
	CODIGO VARCHAR2(30) NOT NULL ENABLE,
        SUPERFICIE NUMBER(5,0),
        PLANTA VARCHAR2(15),
        DORMITORIOS NUMBER(2,0), 
	TIPO VARCHAR2(30 BYTE),
	CONSTRAINT PK_INMUEBLES PRIMARY KEY (IDINMUEBLE) ENABLE,
        CONSTRAINT UN_CODIGO_INMUEBLES UNIQUE (CODIGO)
   ) ;



 CREATE TABLE TIEMPO (
   	IDTIEMPO NUMBER(5,0) NOT NULL ENABLE, 
	ANYO INTEGER,
	MES VARCHAR2(20),
	NUMMES NUMBER(2,0),
	 CONSTRAINT PK_TIEMPO PRIMARY KEY (IDTIEMPO) ENABLE
   ) ;



 CREATE TABLE ZONAS 
   (	IDZONA NUMBER(5,0) NOT NULL ENABLE, 
	PAIS VARCHAR2(100 BYTE), 
	PROVINCIA VARCHAR2(100 BYTE), 
	COMARCA VARCHAR2(100 BYTE), 
	MUNICIPIO VARCHAR2(100 BYTE), 
	DISTRITO VARCHAR2(100 BYTE), 
	BARRIO VARCHAR2(100 BYTE), 
	 CONSTRAINT PK_ZONA PRIMARY KEY (IDZONA) ENABLE
   ) ;



 CREATE TABLE OFERTAS (
   	IDINMUEBLE NUMBER(15,0) NOT NULL ENABLE, 
        IDTIEMPO NUMBER(5,0) NOT NULL ENABLE, 
        IDZONA  NUMBER(5,0) NOT NULL ENABLE, 
	PRECIO NUMERIC(15,0),    --hasta 100 millones
        PRECIOINICIAL NUMERIC(15,0),
        VENDIDO VARCHAR2(2),
        MESESVTA NUMBER(3,0), 
	REVALORACION NUMBER(15,0),
	 CONSTRAINT PK_OFERTAS PRIMARY KEY (IDINMUEBLE,IDTIEMPO) ENABLE,
         CONSTRAINT FK_OFERTAS2INMUEBLE foreign key (IDINMUEBLE) 
             REFERENCES INMUEBLES (IDINMUEBLE) ENABLE,
        CONSTRAINT FK_OFERTAS2TIEMPO foreign key (IDTIEMPO) 
            REFERENCES TIEMPO (IDTIEMPO) ENABLE,
        CONSTRAINT FK_OFERTAS2ZONA foreign key (IDZONA) 
            REFERENCES ZONAS (IDZONA) ENABLE
   ) ;


  CREATE TABLE "TEMP_DATOS" 
   (	"ID" NUMBER, 
	"CODI" VARCHAR2(255 BYTE), 
	"ZONA" VARCHAR2(30 BYTE), 
	"TIPUS" VARCHAR2(30 BYTE), 
	"PLANTA" VARCHAR2(15 BYTE), 
	"DORMITORIS" VARCHAR2(15 BYTE), 
	"METRES" VARCHAR2(15 BYTE), 
	"CAMPO1" VARCHAR2(30 BYTE), 
	"CAMPO2" VARCHAR2(30 BYTE), 
	"CAMPO3" VARCHAR2(30 BYTE), 
	"CAMPO4" VARCHAR2(30 BYTE), 
	"CAMPO5" VARCHAR2(30 BYTE), 
	"CAMPO6" VARCHAR2(30 BYTE), 
	"CAMPO7" VARCHAR2(30 BYTE), 
	"CAMPO8" VARCHAR2(30 BYTE), 
	"CAMPO9" VARCHAR2(30 BYTE), 
	"CAMPO10" VARCHAR2(30 BYTE), 
	"CAMPO11" VARCHAR2(30 BYTE), 
	"CAMPO12" VARCHAR2(30 BYTE), 
	"CAMPO13" VARCHAR2(30 BYTE), 
	"CAMPO14" VARCHAR2(30 BYTE), 
	"CAMPO15" VARCHAR2(30 BYTE), 
	"CAMPO16" VARCHAR2(30 BYTE), 
	"CAMPO17" VARCHAR2(30 BYTE), 
	"CAMPO18" VARCHAR2(30 BYTE), 
	"CAMPO19" VARCHAR2(30 BYTE), 
	"CAMPO20" VARCHAR2(30 BYTE), 
	"CAMPO21" VARCHAR2(30 BYTE), 
	"CAMPO22" VARCHAR2(30 BYTE), 
	"CAMPO23" VARCHAR2(30 BYTE), 
	"CAMPO24" VARCHAR2(30 BYTE), 
	"CAMPO25" VARCHAR2(30 BYTE), 
	"IDZONA" NUMBER(5,0), 
	"IDINMUEBLE" NUMBER(15,0)
   ) ;


CREATE TABLE TEMP_INTERVALZONAS 
   (	ID NUMBER(10,0) NOT NULL ENABLE, 
	ID_TO_DATOS_TEMP NUMBER(15,0) NOT NULL ENABLE, 
	IDZONA NUMBER(5,0), 
	CODI VARCHAR2(255 BYTE), 
	DESDE NUMBER(15,0), 
	HASTA NUMBER(15,0)
   ) ;

commit;


create or replace trigger TR_INMUEBLES_SEQ     before insert on INMUEBLES 
for each row begin     
   if inserting then       
      if :NEW.IDINMUEBLE is null then          
           select SEQ_INMUEBLES.nextval into :NEW.IDINMUEBLE
           from dual;       
      end if;    
    end if; 
end;
/


create or replace trigger TR_TIEMPO_SEQ     before insert on TIEMPO 
for each row begin     
   if inserting then       
      if :NEW.IDTIEMPO is null then          
           select SEQ_TIEMPO.nextval into :NEW.IDTIEMPO
           from dual;       
      end if;    
    end if; 
end;
/

create or replace trigger TR_ZONAS_SEQ    before insert on ZONAS 
for each row begin     
   if inserting then       
      if :NEW.IDZONA is null then          
           select SEQ_ZONA.nextval into :NEW.IDZONA
           from dual;       
      end if;    
    end if; 
end;
/

CREATE OR REPLACE TRIGGER TR_TEMP_INTERVALZONAS_SEQ before insert on TEMP_INTERVALZONAS 
for each row begin     
   if inserting then       
      if :NEW.ID is null then          
           select SEQ_TEMP_INTERVALZONAS.nextval into :NEW.ID
           from dual;       
      end if;    
    end if; 
end;
/

create or replace trigger TR_TEMP_DATOS     before insert on TEMP_DATOS 
for each row begin  

   if inserting then  
   
    if (SUBSTR(:NEW.CODI,1,1)<>'#') then
    
          
          if (:NEW.TIPUS<>'chalets') AND (:NEW.PLANTA='--')  then          
               raise_application_error(-20500, 'ERROR: Planta no definida.');     
          end if;    
         
          if (:NEW.TIPUS<>'estudios') AND (:NEW.DORMITORIS='0')  then  
              raise_application_error(-20501, 'ERROR: Dormitoris sin definir.');  
          end if; 
          
         
          if (:NEW.TIPUS='ticos') AND (:NEW.PLANTA in ('bj','en','pp','ss','st'))  then
            raise_application_error(-20502, 'ERROR: ticos en planta no vlida.');
          end if;
          
         
          if (isNumeric(:NEW.DORMITORIS)='1') then
            if (TO_NUMBER(:NEW.DORMITORIS)>25)  then
              raise_application_error(-20503, 'ERROR: Supera los 25 dormitorios.');
            end if;
          end if;
          

          if (:NEW.TIPUS <>'chalets') AND  (isNumeric(:NEW.PLANTA)='1')  then
            if (TO_NUMBER(:NEW.PLANTA)>60) then
              raise_application_error(-20504, 'ERROR: Supera la 60 planta.');
            end if;
          end if;
      end if;
    end if; 
end;
/
commit;
create or replace procedure SetUpDatosyUmbrales is
    
    v_time_ini varchar2(10);
    v_time_fin varchar2(10);
BEGIN

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_ini from dual;
      dbms_output.put_line('Procedure SetUpDatosyUmbrales inicio en: '||v_time_ini);
    --#####################################################
    --DORMITORIOS
    --#####################################################
    --estudios sin dormitorios -> dormitorios =0
    UPDATE TEMP_DATOS SET Dormitoris=0 where tipus='estudios';
    
    --#####################################################
    --PLANTAS
    --#####################################################
    --los chalets no se encuentran en ninguna planta
    UPDATE TEMP_DATOS SET Planta=null where tipus='chalets';
    
    --#####################################################
    --MINIMAS Y MAXIMAS SUPERFICIES
    --#####################################################
    --superficie minima para todo inmueble
    UPDATE TEMP_DATOS SET metres=null where  substr(codi,1,2)='VC' and to_number(metres)<20;
    --superficie maxima para chalets
    UPDATE TEMP_DATOS SET metres= NULL WHERE tipus ='chalets' AND to_number(metres)>2500;
    --superficie maxima para estudios
    UPDATE TEMP_DATOS SET metres= NULL WHERE  tipus ='estudios' AND to_number(metres)>100;
    --superficie maxima para dplex
    UPDATE TEMP_DATOS SET metres= NULL WHERE  tipus ='dplex' AND to_number(metres)>900;
    --superficie maxima para ticos y pisos
    UPDATE TEMP_DATOS SET metres= NULL WHERE  tipus ='ticos' AND to_number(metres)>600;
    UPDATE TEMP_DATOS SET metres= NULL WHERE  tipus ='pisos' AND to_number(substr(metres,1,1))>'6' and length(metres)>=3;
    
    commit;
    select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_fin from dual;
    dbms_output.put_line('Procedure SetUpDatosyUmbrales finaliza en: '||v_time_fin);
   
END;
/
create or replace procedure SetUpTEMPINTERVALOS IS

  CURSOR c_codi  is 
      SELECT id,upper(substr(codi,1,1))
       FROM TEMP_DATOS
        order by id asc;

    v_time_ini varchar2(10);
    v_time_fin varchar2(10);
    v_id number(15,0);
    v_ant number(15,0);
    v_codi varchar2(1);
    v_desde number(15,0);
    v_id_zona number(15,0);  --identificador del registro de temp_datos donde esta la jerarquia v_codi
    v_IdZona  number(5,0); --identificador secuencial tras insertar en la tabla.
    buscaV number(1,0);
  
BEGIN

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_ini from dual;
      dbms_output.put_line('Procedure SetUp_TEMP_INTERVALOS inicio en: '||v_time_ini);
      
      --inicializacion
      buscaV:=1;
      
    OPEN c_codi;
      --inicializacion 1 registro
      FETCH c_codi INTO v_id,v_codi; 
      v_ant:=v_id;
      
      LOOP    
        FETCH c_codi INTO v_id,v_codi;    
        EXIT WHEN c_codi%NOTFOUND;
        
          --BUSCANDO V
          IF (buscaV=1) then
            IF v_codi='V' THEN
                v_desde:=v_id; buscaV:=0;
                select id  into v_id_zona from temp_datos where id=v_ant;
            END IF;
          --BUSCANDO #
          ELSE
            IF v_codi='#' THEN 
                buscaV:=1;
                INSERT INTO TEMP_INTERVALZONAS (ID_TO_DATOS_TEMP,DESDE,HASTA) VALUES (v_id_zona,v_desde,v_ant);
                
            END IF;
          END IF;
          v_ant:=v_id;
      END LOOP;  
      
        --condicion final
        INSERT INTO TEMP_INTERVALZONAS (ID_TO_DATOS_TEMP,DESDE,HASTA) VALUES (v_id_zona,v_desde,v_ant);
 
    CLOSE c_codi;
    
    --actualizamos el codi
    update temp_intervalzonas set codi=(select codi from temp_datos where id=temp_intervalzonas.ID_TO_DATOS_TEMP);
    commit;

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_fin from dual;
      dbms_output.put_line('Procedure SetUp_TEMP_INTERVALOS finaliza en: '||v_time_fin);

END SetUpTEMPINTERVALOS;

/
create or replace procedure SetUpZonas is
    
    v_time_ini varchar2(10);
    v_time_fin varchar2(10);
    
  CURSOR c_zonas IS 
    select id,codi from temp_intervalzonas  order by id asc FOR UPDATE;
    
    TYPE regzona IS RECORD(
      pais zonas.PAIS%TYPE ,
      provincia zonas.PROVINCIA%TYPE,
      comarca zonas.COMARCA%TYPE,
      municipio zonas.MUNICIPIO%TYPE,
      distrito zonas.DISTRITO%TYPE,
      barrio zonas.BARRIO%TYPE
    );

    v_reg regzona;
    v_codi temp_datos.codi%type;
    subcad1 temp_datos.codi%type; --subcadena de datos a clasificar
    subcad2 temp_datos.codi%type; --resto de la cadena
    v_nivel int;
    v_id number(5,0);
    v_cont int;
    miidzona number(5,0);
    v_desde number(15,0);
    v_hasta number(15,0);
BEGIN

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_ini from dual;
      dbms_output.put_line('Procedure SetUpZonas inicio en: '||v_time_ini);

   OPEN c_zonas;
   FETCH c_zonas into v_id,v_codi;
   WHILE c_zonas%FOUND
      LOOP
      --------------------------------------------------------------
      --Inicializaciones
      --subcad2:=replace(v_codi,'#  ::: ',''); --eliminamos prefijo inicial
      v_reg.pais:='ESPAA';v_reg.provincia:='<PROVINCIA>';v_reg.comarca:='<COMARCA>';
      v_reg.municipio:='<MUNICIPIO>';v_reg.distrito:='<DISTRITO>';v_reg.barrio:='<BARRIO>';v_nivel:=1;
      --dbms_output.put_line(v_codi);
      --------------------------------------------------------------
      WHILE (instr(v_codi,' ::: ')<>0)  LOOP
        --dbms_output.put_line('loop');dbms_output.put_line(v_nivel);
        v_codi:=substr(v_codi,instr(v_codi,' ::: ')+5);
        
        IF instr(v_codi,' ::: ')<>0 THEN 
          subcad1:=substr(v_codi,1,instr(v_codi,' ::: ')-1);
        ELSE 
          subcad1:=v_codi;
        END IF;
        
        --dbms_output.put_line('v_codi y subcad1');dbms_output.put_line(v_codi);dbms_output.put_line(subcad1);
        --si hay cadenas con ms de 5 niveles, los niveles restantes se ignoran
        --y si son menores que 5 se quedan con el valor con el que se han inicializado
        IF v_nivel=1 THEN 
            v_reg.provincia:=UPPER(subcad1); 
            IF instr(subcad1,'andorra')<>0 THEN v_reg.pais:='ANDORRA';END IF;
        END IF;
        
        IF v_nivel=2 THEN v_reg.comarca:=UPPER(subcad1); END IF;
        IF v_nivel=3 THEN v_reg.municipio:=UPPER(subcad1); END IF;
        IF v_nivel=4 THEN v_reg.distrito:=UPPER(subcad1); END IF;
        IF v_nivel=5 THEN v_reg.barrio:=UPPER(subcad1); END IF;
        
        v_nivel:=v_nivel +1;
        
      END LOOP;
     --------------------------------------------------------------
      v_cont:=0;
      select count(*) into v_cont from ZONAS where pais= v_reg.pais and comarca=v_reg.comarca
      and municipio=v_reg.municipio and distrito=v_reg.distrito and barrio=v_reg.barrio;
      
      if v_cont=0 then
        insert into ZONAS (pais,provincia,comarca,municipio,distrito,barrio) values 
        (v_reg.pais,v_reg.provincia,v_reg.comarca,v_reg.municipio,v_reg.distrito,v_reg.barrio);
      end if;
      
      select idzona into miidzona from ZONAS where PAIS= v_reg.pais and PROVINCIA=v_reg.provincia 
      and COMARCA=v_reg.comarca and MUNICIPIO=v_reg.municipio and DISTRITO=v_reg.distrito and BARRIO=v_reg.barrio;
     
      update TEMP_INTERVALZONAS set IDZONA=miidzona where id=v_id;
      select desde,hasta into v_desde,v_hasta from  TEMP_INTERVALZONAS  where id=v_id; 
      update temp_datos set idzona=miidzona where id between v_desde and v_hasta ;
     --------------------------------------------------------------
      FETCH c_zonas into v_id,v_codi;
      END LOOP;
    CLOSE c_zonas;
	commit;
    select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_fin from dual;
    dbms_output.put_line('Procedure SetUpZonas finaliza en: '||v_time_fin);
    
 END SetUpZonas;
 /
create or replace procedure InsertaInmuebles as
    v_time_ini varchar2(10);
    v_time_fin varchar2(10);
BEGIN
      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_ini from dual;
      dbms_output.put_line('Procedure InsertaInmuebles inicio en: '||v_time_ini);
      
      MERGE INTO inmuebles i 
      USING (select codi,metres,planta,dormitoris,tipus from temp_datos where upper(substr(codi,1,1))='V') a 
      ON (i.codigo = a.codi) 
      WHEN MATCHED THEN 
      UPDATE SET 
        superficie=a.metres,planta=a.planta,dormitorios=a.dormitoris,tipo=a.tipus
        
      WHEN NOT MATCHED THEN 
      INSERT (codigo, superficie, planta,dormitorios,tipo) VALUES (a.codi,a.metres,a.planta,a.dormitoris,a.tipus);

    --inserta en temp_datos para facilitar consultas posteriores
    update temp_datos ft
    set idinmueble = (select idinmueble  from inmuebles ct 
     where ft.codi = ct.codigo);
     
     commit;
      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_fin from dual;
      dbms_output.put_line('Procedure InsertaInmuebles final en: '||v_time_fin);
 END InsertaInmuebles; 
/
 create or replace procedure CargaFechasOfertas AS
      
    numcols integer:=1;                 --generador de numeros de campos
      nom_col TEMP_DATOS.CAMPO1%TYPE;     --nombre de la columna de datos
      str_sql VARCHAR2(100);              --sentencia parametrizada a ejecutar
      str_sql_into VARCHAR2(255);
      str_sql_delete VARCHAR2(255);
      fechaoferta temp_datos.campo1%type; --
      v_mes varchar2(30);
      v_anyo number(5,0);
      v_idtiempo number(5,0);
      v_time_ini varchar2(10);
      v_time_fin varchar2(10);
      
BEGIN

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_ini from dual;
      dbms_output.put_line('Procedure CargaFechasOfertas inicio en: '||v_time_ini);
      
        WHILE (numcols<26) LOOP
            ------------------------------------------------------------------------------------
            --para cada columna de fecha de oferta con datos
            ------------------------------------------------------------------------------------
            
                  /**************  obtengo fecha y el idtiempo correspondiente ***************************/
                  str_sql:='select CAMPO' || numcols|| ' from temp_datos where id=1 and CAMPO'  || numcols|| ' is not null';
                  --dbms_output.put_line(str_sql);
                  EXECUTE IMMEDIATE str_sql INTO fechaoferta;
                  --dbms_output.put_line(fechaoferta);
                  --ahora obtener mes y anyo 
                  v_mes:= UPPER(substr(fechaoferta,6,(instr(fechaoferta,' ',6) - instr(fechaoferta,' ',1))-1)) ; --mes
                  v_anyo:=substr(fechaoferta,length(fechaoferta)-3,length(fechaoferta));--anyo
                  --dbms_output.put_line(v_mes||' / '||v_anyo);
                  
                  dbms_output.put_line('Insertando ofertas: ' || numcols || '/25...');
                  
                  MERGE INTO tiempo t                 --inserto la fecha en la tabla si no existe
                  USING (select v_mes as mes,v_anyo as anyo from dual) a 
                  ON (t.mes=a.mes and t.anyo=a.anyo) 
                  WHEN NOT MATCHED THEN 
                  INSERT (mes,anyo) VALUES (v_mes,v_anyo);
                  
                  select idtiempo into v_idtiempo from tiempo where mes=v_mes and anyo=v_anyo;    --obtendo el identificador
                  
                /*************  inserto las ofertas de la fecha indicada **************************/
                  --Borrado previo
		
                  str_sql_delete:='delete ofertas ' ||
                  'where idtiempo=' ||v_idtiempo|| 'and idinmueble in ('||
                  'select idinmueble from temp_datos )';
                   EXECUTE IMMEDIATE str_sql_delete; 
                   commit;
                 
		 
                  --Insercion                  
                  str_sql_into:='insert into ofertas (idinmueble,idtiempo,idzona,precio) '||
                  ' select idinmueble,'||v_idtiempo||',idzona,CAMPO' || numcols ||
                  ' from temp_datos where idinmueble is not null';
                 
                   EXECUTE IMMEDIATE str_sql_into;
                   commit;
            ------------------------------------------------------------------------------------
            --retorno de columna con fecha de datos
            ------------------------------------------------------------------------------------
            numcols:=numcols+1;
        END LOOP;
		
	update tiempo set nummes= (case  mes
	    when 'GENER' THEN 1
	    when 'FEBRER' THEN 2
	    when 'MAR' THEN 3
	    when 'ABRIL' THEN 4
	    when 'MAIG' THEN 5
	    when 'JUNY' THEN 6
	    when 'JULIOL' THEN 7
	    when 'AGOST' THEN 8
	    when 'SETEMBRE' THEN 9
	    when 'OCTUBRE' THEN 10
	    when 'NOVEMBRE' THEN 11
	    when 'DESEMBRE' THEN 12
	    end);

      commit;
      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_fin from dual;
      dbms_output.put_line('Procedure CargaFechasOfertas final en: '||v_time_fin);
      end CargaFechasOfertas;
      
      
/
create or replace procedure SetOfertas as

    CURSOR c_inmu IS 
    SELECT idinmueble FROM temp_datos 
    --WHERE idinmueble between 1 and 20; --PRUEBAS
   WHERE idinmueble is not null;
    
    CURSOR c_inmuofer(VIN_IDINMUEBLE IN NUMBER) IS 
    SELECT o.precio,t.idtiempo FROM ofertas o, tiempo t
    WHERE o.idinmueble = VIN_IDINMUEBLE and t.idtiempo=o.idtiempo order by (t.anyo*10000)+t.nummes;
    
    v_precio_ini number(15,0);
    v_ant_precio number(15,0);
    v_mesesvta number(5,0);
    v_enVenta number(1,0);
    v_primvez number(1,0);
    v_ant_idtiempo number(5,0);
    v_esteprecio number(15,0);
    v_esteidinmueble number(10,0);
    v_esteidtiempo number(5,0);
    v_reval number(15,0);
    v_time_ini varchar2(10);
    v_time_fin varchar2(10);
    
BEGIN

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_ini from dual;
      dbms_output.put_line('Procedure SetOfertas inicio en: '||v_time_ini);
      
  --v_contprecio:=0;v_contador:=0;
  FOR reg_inmu IN c_inmu LOOP
    --Inicializaciones
    v_precio_ini:=null; v_ant_precio:=null;v_mesesvta:=0;v_reval:=null;    v_enVenta:=0;v_primvez:=1;    v_ant_idtiempo:=null;
    
    FOR reg_inmuofer IN c_inmuofer(reg_inmu.idinmueble) LOOP
      v_esteidinmueble:=reg_inmu.idinmueble;
      v_esteprecio:=reg_inmuofer.precio;
      v_esteidtiempo:=reg_inmuofer.idtiempo;
      ----------------------------------------------
      --esta parte solamente se ejecuta la primera vez para tener 
      --un puntero a la oferta anterior a la acutal
      if v_primvez=1 then
        if v_esteprecio is not null then
            --//valores                         // conteo                   //control                    //paso atras                      
            v_precio_ini:=v_esteprecio; v_mesesvta:=v_mesesvta+1;   v_enVenta:=1;v_primvez:=0;   v_ant_idtiempo:=v_esteidtiempo; v_ant_precio:=v_esteprecio;
        else
          v_primvez:=0; --//control
        end if;
        ----------------------------------------------
      else --(v_primvez=0)
        
         IF v_esteprecio is null THEN       --todavia no se ha puesto a la venta o se vendi el mes anterior
         
            IF v_enVenta=0  THEN                --EL INMUEBLE AN NO EST EN PERIODO DE VENTA
              null;
            ELSE                                --EL INMUEBLE SE VENDIO EN EL MES ANTERIOR
              UPDATE ofertas set mesesvta=v_mesesvta,vendido='SI',precioinicial=v_precio_ini
                    where idinmueble=v_esteidinmueble and idtiempo=v_ant_idtiempo;
              if (v_reval<>0) then
                 UPDATE ofertas set revaloracion=v_reval  where idinmueble=v_esteidinmueble and idtiempo=v_ant_idtiempo;
              end if;
              v_enVenta:=0;v_precio_ini:=null;v_mesesvta:=0;v_reval:=null;
            END IF;
            
         ELSE --(reg_inmuofer.precio<>null)     --se trata de la primera oferta del historial o sigue en venta
         
            IF v_enVenta=0  THEN                --SE INICA UN PERIODO DE VENTA
              v_precio_ini:=v_esteprecio;v_ant_precio:=v_esteprecio;v_enVenta:=1;v_mesesvta:=v_mesesvta+1;v_reval:=null;
              
            ELSE                                --EL INMUEBLE SIGUE EN VENTA
                --actualizo la apreciacion solo si la hay
                select (v_esteprecio-v_ant_precio) into v_reval from dual; 
                UPDATE ofertas set  revaloracion=v_reval where idinmueble=v_esteidinmueble and idtiempo=v_esteidtiempo and v_reval<>0;             
                v_mesesvta:=v_mesesvta+1;
               
            END IF;
            
         END IF; --reg_inmuofer.precio=null
      end if; --v_primvez=1
      -----------------------------------------------------------
      v_ant_idtiempo:=reg_inmuofer.idtiempo;v_ant_precio:=v_esteprecio;
      -----------------------------------------------------------
  END LOOP;
    --al cambiar de inmueble , habra que hacer una actualizacion si sigue en oferta
         UPDATE ofertas     set vendido='NO',
                            precioinicial=v_esteprecio,
                            mesesvta=v_mesesvta
            where idinmueble=v_esteidinmueble and idtiempo=v_ant_idtiempo and v_enVenta=1 ;
        
         if v_reval <>0 then
          update ofertas set revaloracion=v_reval where idinmueble=v_esteidinmueble and idtiempo=v_ant_idtiempo and v_enVenta=1 ; 
         end if;
  commit;
END LOOP;

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_fin from dual;
      dbms_output.put_line('Procedure SetOfertas final en: '||v_time_fin);

END SetOfertas ;
/
create or replace procedure ProcesaDatosCargados AS

    v_time_ini varchar2(10);
    v_time_fin varchar2(10);

BEGIN
dbms_output.put_line('************************************************');
      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_ini from dual;
      dbms_output.put_line('Procedure ProcesaDatosCargados inicio en: '||v_time_ini);
      commit;
      SetUpDatosyUmbrales;
      SetUpTEMPINTERVALOS;
      SetUpZonas;
      InsertaInmuebles;
      CargaFechasOfertas;
      SetOfertas;

      select to_char(sysdate,'HH')||':'||to_char(sysdate,'mi') ||':'||to_char(sysdate,'ss') sec into v_time_fin from dual;
      dbms_output.put_line('Procedure ProcesaDatosCargados finalizado en: '||v_time_fin);
dbms_output.put_line('************************************************');
      commit;
END ProcesaDatosCargados;
/
commit;

